const navigationBarHeight = (getApp().statusBarHeight + 60) + 'px'
const util = require("../../utils/util.js");
const Http = require("../../utils/HttpBasics");
const config = require("../../config/config");
const imgurl = require("../../utils/imgurl");

Page({
  /**
   * 页面的初始数据
   */
  data: {
    childArr: [],
    navigationBarHeight,
    chevronUrl: imgurl.chevron.url,
    date: '1988-03-12',
    dateEnd: '',
    flag: 1,
    flagsex: 0,
    height: "",
    weight: "",
    items: [
      { name: 1, value: '男', checked: false },
      { name: 2, value: '女', checked: false },
    ],
    username: "",
    array: ['上班族', '学生', '企业高管', '个体户', '自由职业', '其他'],
    array1: ['附近住户', '距离2km', '距离3km', '更远'],
    index: 0,
    index1: 0,
    showPage: false,
    type: true
  },
  /**
   * 获得生日
   */
  bindDateChange: function (e) {
    this.setData({
      date: e.detail.value,
      flag: 2
    })
  },
  /**
   * 职业
   */
  bindPickerChange: function (e) {
    this.setData({
      index: e.detail.value
    })
  },
  /**
   * 生活半径
   */
  bindPickerChange1: function (e) {
    this.setData({
      index1: e.detail.value
    })
  },
  address: function () {
    return
    // let that = this;
    // wx.choose
    // Location({
    //   success: function (res) {
    //     that.setData({
    //       address: res.name + '(' + res.address + ')',
    //       addressStr: JSON.stringify(res)
    //     })
    //   },
    //   fail: function (error) {
    //     console.log(error)
    //   },
    //   complete: function (data) {
    //   }
    // })
  },
  formSubmit: function (e) {
    console.log(e.detail, "formSubmit")
    let that = this;
    // console.log(that.data.childArr)
    /**
     * sex
     * 0 保密
     * 1 男
     * 2 女
     */
    if (that.data.flagsex == 0) {
      var sex = 0;
    } else {
      var sex = that.data.sex;
    }
    if (that.data.addressStr) {
      var address = that.data.addressStr;
    }
    else {
      var address = null;
    }
    if (e.detail.value.username) {
      var username = e.detail.value.username;
    }
    else if (that.data.username) {
      var username = that.data.username;
    }
    else {
      var username = null;
    }
    if (that.data.flag == 2 && that.data.date) {
      var birthdate = new Date(that.data.date).getTime();
    } else {
      var birthdate = null;
    }
    // if (username == null || address == null || sex == 0 || birthdate == null) {
    //   wx.showToast({chidName
    //     title: '请输入完整的用户信息',
    //     icon: "none"
    //   })
    // } else {}
    if (!that.data.type) {
      let tempArr = []
      tempArr = JSON.parse(JSON.stringify(that.data.childArr))
      tempArr.map(item => {
        if (item.birthdate) {
          item.birthdate = new Date(item.birthdate).getTime()
          let data = JSON.stringify(tempArr)
          Http.post({
            url: '/userBasicInfoChild/saveList', data
          }).then(res => {
            console.log(res);
            if (res.code == 200) {
              wx.showToast({
                title: "信息提交成功，将在3分钟内生效",
                icon: 'none',
                duration: 2000,
                mask: false
              })
              setTimeout(() => {
                wx.navigateBack()
              }, 2000)
            }
          }).catch(err => {
            console.log(err);
          })
        } else {
          wx.showToast({
            title: '请填写生日',
            icon: 'warning',
            duration: 2000,
          })
          return
        }
      })

    }
    return
    Http.post({
      url: config.api.updateInfo,
      data: {
        sex: sex,
        address: address,
        name: username,
        birthdate: birthdate,
        childrenList: tmeparr,
        height: e.detail.value.height ? e.detail.value.height : that.data.height,
        weight: e.detail.value.weight ? e.detail.value.weight : that.data.weight,
      }
    })
      .then(res => {
        wx.showToast({
          title: "信息提交成功，将在3分钟内生效",
          icon: 'none',
          duration: 2000,
          mask: false
        }),
          setTimeout(() => {
            wx.navigateBack()
          }, 2000)
      })
      .catch(err => {
        wx.showToast({
          title: err.message,
          icon: 'none',
          duration: 2000,
          mask: false
        })
      })

  },
  radioChange: function (e) {
    this.setData({
      sex: e.detail.value,
      flagsex: 1
    })
  },
  childSex(e) {
    let index = e.currentTarget.dataset.index
    let tmpeObj = this.data.childArr
    tmpeObj[index].sex = e.detail.value
    this.setData({
      childArr: tmpeObj
    })
    console.log(tmpeObj)
  },
  chidBirthday(e) {
    let index = e.currentTarget.dataset.index
    let tmpeObj = this.data.childArr
    tmpeObj[index].birthdate = e.detail.value
    this.setData({
      childArr: tmpeObj
    })
  },
  chidName(e) {
    let index = e.currentTarget.dataset.index
    let tempObj = this.data.childArr
    tempObj[index].name = e.detail.value
    this.setData({
      childArr: tempObj
    })
  },
  childDel(e) {
    let index = e.currentTarget.dataset.index
    let id = null
    let tmpeObj = this.data.childArr
    tmpeObj.splice(index, 1)
    this.setData({
      childArr: tmpeObj
    })
    if (e.currentTarget.dataset.id) {
      id = e.currentTarget.dataset.id
      Http.get({
        url: `/userBasicInfoChild/del?id=${id}`,
      }).then(res => {
        console.log(res);
        wx.showToast({
          title: "删除成功",
          icon: 'none',
          duration: 2000
        })
      }).catch(err => {
        console.log(err);
      })
    }
  },
  childAdd() {
    let tmpeObj = this.data.childArr
    tmpeObj.unshift({ sex: 1 })
    this.setData({
      childArr: tmpeObj
    })
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    if (1 * options.type) {
      this.setData({
        type: false
      })
    }

    Http.get({
      url: '/userBasicInfoChild/list?pageNum=1&pageSize=100',
    }).then(res => {
      console.log(res);
      if (res.data.list) {
        let tmpeArr = res.data.list
        tmpeArr.map(item => {
          item.birthdate = util.fmtDate(parseInt(item.birthdate))
          that.setData({
            childArr: tmpeArr
          })
        })
      }
    }).catch(err => {
      console.log(err)
    })

    let tmpeDateEnd = util.formatTime(new Date(), "yyyy-MM-dd")
    let that = this;
    that.setData({
      dateEnd: tmpeDateEnd
    })
    Http.get({
      url: config.api.getScore,
      data: {},
    })
      .then(res => {
        if (res.code == 200) {
          if (res.data.weight) {
            this.setData({
              weight: res.data.weight
            })
          }
          if (res.data.height) {
            this.setData({
              height: res.data.height
            })
          }

          if (res.data.childrenList) {
            let tmpeArr = res.data.childrenList
            tmpeArr.map(item => {
              item.birthdate = util.fmtDate(parseInt(item.birthdate))
              that.setData({
                childArr: tmpeArr
              })
            })
          }
          that.setData({
            showPage: true,
          })
        }
        var reg = RegExp(/address/);
        if (res && res.data && res.data.address && res.data.address.match(reg)) {
          that.setData({
            address: JSON.parse(res.data.address).address + JSON.parse(res.data.address).name,
            addressStr: JSON.parse(res.data.address).address + JSON.parse(res.data.address).name
          })
        } else {
          that.setData({
            address: res.data.address,
            addressStr: res.data.address
          })
        }
        if (res.data.name) {
          that.setData({
            username: res.data.name
          })
        }
        if (res.data.sex) {
          if (res.data.sex == 1) {
            var checked = 'items[' + 0 + '].checked'
            that.setData({
              [checked]: true,
              flagsex: 1
            })
          } else if (res.data.sex == 2) {
            var checked = 'items[' + 1 + '].checked'
            that.setData({
              [checked]: true,
              flagsex: 1
            })
          }
          that.setData({
            sex: res.data.sex
          })
        }
        if (res.data.birthdate) {
          that.setData({
            date: util.fmtDate(parseInt(res.data.birthdate)),
            flag: 2
          })
        }
      })
      .catch(error => {
        wx.showToast({
          title: error.errMsg,
          icon: 'none',
          duration: 2000,
          mask: false
        });
      })
  }
})